
function [cost] = objective(X, Y, f, h, Q, R, Q0, x0, withAC)
    N = size(X, 2);
    
    if withAC
        cost =  (X(:, 1) - x0)' * (Q0\(X(:, 1) - x0)); 
    else
        cost = 0;
    end
    
    Q_inv = inv(Q);
    R_inv = inv(R);

    for k=1:N-1
        x_current = X(:, k);
        x_next = X(:, k+1);
        w = x_next - f(x_current);
        v = Y(:, k) - h(x_current);
        cost = cost + w' * Q_inv * w + v' * R_inv * v;
    end
    
    v = Y(:, end) - h(X(:, end));
    cost = cost  + v' * R_inv * v;
end